package worldcontrolteam.worldcontrol.blocks;

import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyDirection;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;
import worldcontrolteam.worldcontrol.utils.WCUtility;

import java.util.Random;

public abstract class BlockBasicRotate extends BlockBasicTileProvider {

    public static final PropertyDirection FACING = PropertyDirection.func_177714_a("facing");


    public BlockBasicRotate(Material material, String name) {
        super(material, name);
    }


    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase entity, ItemStack stack) {
        super.func_180633_a(world, pos, state, entity, stack);
        world.func_180501_a(pos, state.func_177226_a(FACING, EnumFacing.func_190914_a(pos, entity)), 2);
    }

    @Override
    public void func_180663_b(World world, BlockPos pos, IBlockState state) {
        dropItems(world, pos);
        super.func_180663_b(world, pos, state);
    }

    private void dropItems(World world, BlockPos pos) {
        Random rand = new Random();

        WCUtility.getTileEntity(world, pos).filter(te -> te.hasCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null)).ifPresent(tileEntity -> {
            IItemHandler handler = tileEntity.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
            for (int i = 0; i < handler.getSlots(); i++) {
                ItemStack item = handler.getStackInSlot(i);

                if (item != ItemStack.field_190927_a && item.func_190916_E() > 0) {
                    float rx = rand.nextFloat() * 0.8F + 0.1F;
                    float ry = rand.nextFloat() * 0.8F + 0.1F;
                    float rz = rand.nextFloat() * 0.8F + 0.1F;

                    EntityItem entityItem = new EntityItem(world, pos.func_177958_n() + rx, pos.func_177956_o() + ry, pos.func_177952_p() + rz, item.func_77946_l());

                    float factor = 0.05F;
                    entityItem.field_70159_w = rand.nextGaussian() * factor;
                    entityItem.field_70181_x = rand.nextGaussian() * factor + 0.2F;
                    entityItem.field_70179_y = rand.nextGaussian() * factor;
                    world.func_72838_d(entityItem);
                    item.func_190920_e(0);
                }
            }
            EntityItem e = new EntityItem(world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p(), new ItemStack(this));
            world.func_72838_d(e);
        });
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return this.func_176223_P().func_177226_a(FACING, EnumFacing.func_82600_a(meta));
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(FACING).func_176745_a();
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, FACING);
    }
}
