package worldcontrolteam.worldcontrol.crossmod.industrialcraft2;

import ic2.api.item.ICustomDamageItem;
import ic2.api.reactor.IReactor;
import ic2.api.reactor.IReactorChamber;
import ic2.core.item.reactor.AbstractDamageableReactorComponent;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import worldcontrolteam.worldcontrol.utils.WCUtility;

public class ReactorUtils {

    public static IReactor getReactorAt(World world, BlockPos pos) {
        if (world == null)
            return null;
        TileEntity tile = WCUtility.getTileEntity(world, pos).orElse(null);
        return tile == null ? null : tile instanceof IReactor ? (IReactor) tile : tile instanceof IReactorChamber ? ((IReactorChamber) tile).getReactorInstance() : null;
    }

    public static boolean isProducing(World world, BlockPos pos) {
        return world.func_175687_A(pos) > 0;
    }

    public static int getNuclearCellTimeLeft(ItemStack rStack) {
        return rStack.func_190926_b() ? 0 : rStack.func_77973_b() instanceof AbstractDamageableReactorComponent ? rStack.func_77973_b() instanceof ICustomDamageItem ? ((ICustomDamageItem) rStack.func_77973_b()).getMaxCustomDamage(rStack) - ((ICustomDamageItem) rStack.func_77973_b()).getCustomDamage(rStack) : rStack.func_77958_k() - rStack.func_77952_i() : 0;
    }

}
