package worldcontrolteam.worldcontrol.inventory;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import worldcontrolteam.worldcontrol.items.ItemBaseCard;
import worldcontrolteam.worldcontrol.items.ItemRemotePanel;

public class InventoryItem implements IInventory, ISlotItemFilter {
    public static final int INV_SIZE = 1;
    /**
     * Provides NBT Tag Compound to reference
     */
    private final ItemStack invItem;
    private String name = "Inventory Item";
    private ItemStack[] inventory = new ItemStack[INV_SIZE];

    public InventoryItem(ItemStack stack) {
        this.inventory[0] = ItemStack.field_190927_a;
        this.invItem = stack;
        if (stack != ItemStack.field_190927_a) {
            if (!stack.func_77942_o())
                stack.func_77982_d(new NBTTagCompound());
            readFromNBT(stack.func_77978_p());
        }
    }

    @Override
    public int func_70302_i_() {
        return inventory.length;
    }

    @Override
    public boolean func_191420_l() {
        return false;
    }

    @Override
    public ItemStack func_70301_a(int slot) {
        return inventory[slot] == null ? ItemStack.field_190927_a : inventory[slot];
    }

    @Override
    public ItemStack func_70298_a(int slot, int amount) {
        ItemStack stack = func_70301_a(slot);
        if (stack != ItemStack.field_190927_a)
            if (stack.func_190916_E() > amount) {
                stack = stack.func_77979_a(amount);
                func_70296_d();
            } else func_70299_a(slot, ItemStack.field_190927_a);
        return stack;
    }

    @Override
    public ItemStack func_70304_b(int slot) {
        ItemStack stack = func_70301_a(slot);
        if (stack != ItemStack.field_190927_a)
            func_70299_a(slot, ItemStack.field_190927_a);
        return stack;
    }

    @Override
    public void func_70299_a(int slot, ItemStack itemstack) {
        this.inventory[slot] = itemstack;

        if (!itemstack.func_190926_b() && itemstack.func_190916_E() > this.func_70297_j_())
            itemstack.func_190920_e(this.func_70297_j_());
        func_70296_d();
    }

    @Override
    public String func_70005_c_() {
        return name;
    }

    @Override
    public boolean func_145818_k_() {
        return name.length() > 0;
    }

    @Override
    public ITextComponent func_145748_c_() {
        return new TextComponentString(name);
    }

    @Override
    public int func_70297_j_() {
        return 1;
    }

    @Override
    public void func_70296_d() {
        for (int i = 0; i < func_70302_i_(); ++i)
            if (func_70301_a(i) != ItemStack.field_190927_a && func_70301_a(i).func_190916_E() == 0)
                inventory[i] = ItemStack.field_190927_a;
        if (!invItem.func_77942_o())
            invItem.func_77982_d(new NBTTagCompound());
        writeToNBT(invItem.func_77978_p());
    }

    @Override
    public boolean func_70300_a(EntityPlayer player) {
        return player.func_184586_b(player.func_184600_cs()) == invItem;
    }

    @Override
    public void func_174889_b(EntityPlayer player) {
    }

    @Override
    public void func_174886_c(EntityPlayer player) {
        func_70296_d();
    }

    @Override
    public boolean isItemValid(int slotIndex, ItemStack itemStack) {
        return !(itemStack.func_77973_b() instanceof ItemRemotePanel) && itemStack.func_77973_b() instanceof ItemBaseCard;
    }

    @Override
    public boolean func_94041_b(int slot, ItemStack itemstack) {
        return !(itemstack.func_77973_b() instanceof ItemRemotePanel) && itemstack.func_77973_b() instanceof ItemBaseCard;
    }

    @Override
    public int func_174887_a_(int id) {
        return 0;
    }

    @Override
    public void func_174885_b(int id, int value) {

    }

    @Override
    public int func_174890_g() {
        return 0;
    }

    @Override
    public void func_174888_l() {

    }

    public void readFromNBT(NBTTagCompound compound) {
        NBTTagList items = compound.func_150295_c("item_inventory", compound.func_74732_a());
        for (int i = 0; i < items.func_74745_c(); ++i) {
            NBTTagCompound item = items.func_150305_b(i);
            byte slot = item.func_74771_c("slot");
            if (slot >= 0 && slot < func_70302_i_())
                inventory[slot] = new ItemStack(item);
        }
    }

    public void writeToNBT(NBTTagCompound tagcompound) {
        NBTTagList items = new NBTTagList();

        for (int i = 0; i < func_70302_i_(); ++i)
            if (func_70301_a(i) != ItemStack.field_190927_a) {
                NBTTagCompound item = new NBTTagCompound();
                item.func_74768_a("slot", i);
                func_70301_a(i).func_77955_b(item);
                items.func_74742_a(item);
            }
        tagcompound.func_74782_a("item_inventory", items);
    }

}
