package worldcontrolteam.worldcontrol.items;

import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import worldcontrolteam.worldcontrol.api.card.CardState;
import worldcontrolteam.worldcontrol.api.card.predefs.IProviderCard;
import worldcontrolteam.worldcontrol.api.card.predefs.StringWrapper;
import worldcontrolteam.worldcontrol.utils.NBTUtils;
import worldcontrolteam.worldcontrol.utils.WCUtility;

import java.util.List;

public abstract class ItemBaseCard extends WCBaseItem implements IProviderCard {

    public ItemBaseCard(String name) {
        super(name);
    }

    @Override
    public abstract CardState update(World world, ItemStack card);

    @Override
    public abstract List<StringWrapper> getStringData(List<StringWrapper> list, int displaySettings, ItemStack card, boolean showLabels);

    @Override
    public abstract List<String> getGuiData();

    @Override
    @SideOnly(Side.CLIENT)
    public abstract int getCardColor();

    public boolean hasKit() {
        return true;
    }

    @SideOnly(Side.CLIENT)
    @Override
    public void func_77624_a(ItemStack stack, World playerIn, List<String> tooltip, ITooltipFlag advanced) {
        try {
            NBTTagCompound nbt = stack.func_77978_p();
            BlockPos pos = NBTUtils.getBlockPos(nbt);
            int x = pos.func_177958_n();
            int y = pos.func_177956_o();
            int z = pos.func_177952_p();
            tooltip.add(WCUtility.translateFormatted("card.cords", x, y, z));
        } catch (NullPointerException e) {
            tooltip.add(WCUtility.translate("card.no_cords"));
        }
    }
}
