package worldcontrolteam.worldcontrol.tileentity;

import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.play.server.SPacketUpdateTileEntity;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import worldcontrolteam.worldcontrol.blocks.BlockInfoPanel;

import javax.annotation.Nullable;

/**
 * File created by mincrmatt12 on 6/15/2018.
 * Originally written for WorldControl.
 * <p>
 * See LICENSE.txt for license information.
 */
public class TileEntityInfoPanelExtender extends TileEntity {
    public BlockPos origin;
    public EnumFacing facing = EnumFacing.NORTH;

    public TileEntityInfoPanelExtender() {

    }

    public void init() {
        this.facing = (EnumFacing) field_145850_b.func_180495_p(func_174877_v()).func_177228_b().get(BlockInfoPanel.FACING);

    }

    @Nullable
    @Override
    public SPacketUpdateTileEntity func_189518_D_() {
        NBTTagCompound compound = new NBTTagCompound();
        addPosInfo(compound);
        SPacketUpdateTileEntity spute = new SPacketUpdateTileEntity(
                func_174877_v(), 2, compound
        );
        return spute;
    }

    @Override
    public void onDataPacket(NetworkManager net, SPacketUpdateTileEntity pkt) {
        if (pkt.func_148853_f() != 2) return;
        NBTTagCompound compound = pkt.func_148857_g();
        if (compound.func_74767_n("null")) {
            this.origin = null;
        }
        else {
            this.origin = new BlockPos(
                    compound.func_74762_e("ox"),
                    compound.func_74762_e("oy"),
                    compound.func_74762_e("oz")
            );
        }
        IBlockState bs = field_145850_b.func_180495_p(func_174877_v());
        field_145850_b.func_184138_a(func_174877_v(), bs, bs, 0);
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        compound = super.func_189515_b(compound);

        addPosInfo(compound);
        compound.func_74768_a("facing", facing.func_176745_a());
        return compound;
    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        super.func_145839_a(compound);

        if (compound.func_74767_n("null")) {
            this.origin = null;
        }
        else {
            this.origin = new BlockPos(
                    compound.func_74762_e("ox"),
                    compound.func_74762_e("oy"),
                    compound.func_74762_e("oz")
            );
        }

        this.facing = EnumFacing.func_82600_a(compound.func_74762_e("facing"));
    }

    private void addPosInfo(NBTTagCompound compound) {
        if (origin == null) {
            compound.func_74757_a("null", true);
        }
        else {
            compound.func_74757_a("null", false);
            compound.func_74768_a("ox", origin.func_177958_n());
            compound.func_74768_a("oy", origin.func_177956_o());
            compound.func_74768_a("oz", origin.func_177952_p());
        }
    }

    @Override
    public NBTTagCompound func_189517_E_() {
        NBTTagCompound compound = super.func_189517_E_();
        addPosInfo(compound);
        return compound;
    }
}
